stages:
    - setup
    - test
    - build
    - render
    - post-artifacts-creation
    - release
    - cleanup


variables:
  LV_PROJECT_NAME: "Asciidoc for LabVIEW"

workflow:
  rules:
  #Prevent pipelines to run on merge request, Tags and when commit message contains wip 
    - if: $CI_COMMIT_MESSAGE =~ /(?i)Merge tag '[Vv][0-9]+\.[0-9]+\.[0-9]+' into develop|Merge branch 'master' into develop|Merge tag 'Sprint-[0-9]+' into develop/
      when: never
    - if: $CI_COMMIT_BRANCH == "master" && $CI_COMMIT_MESSAGE =~ /Merge branch 'release\/(.*?)|Merge branch 'hotfix\/(.*?)'/
      when: never
    - if: $CI_COMMIT_BRANCH
    - if: $CI_COMMIT_TAG =~ /(?i)[Vv][0-9]+\.[0-9]+\.[0-9]/


Apply VIPC:
    stage: setup
    rules:
      - if: $CI_COMMIT_BRANCH
    tags:
        - LV2014
    script:
        - g-cli --lv-ver 2014 --timeout 30000 ApplyVipc -- -VipcFile "$CI_PROJECT_DIR\$LV_PROJECT_NAME.vipc" -LabviewVersion "14.0"


Mass Compile:
    stage: test
    rules:
      - if: $CI_COMMIT_BRANCH
    tags:
        - LV2014
    script:
        - g-cli --lv-ver 2014 MassCompile -- -Directory "$CI_PROJECT_DIR\Sources" -Cache "20" -r --[0-9]{4}.vi
 

# Unit tests:
#     stage: test
#     rules:
#       - if: $CI_COMMIT_BRANCH
#     dependencies: [] # do not download artifacts from previous jobs    
#     tags:
#         - LV2014
#     script:
#         - g-cli --lv-ver 2014 RunCarayaTests -- -t "$CI_PROJECT_DIR" -rp "$CI_PROJECT_DIR\test-result.xml"
#     artifacts:
#         when: always
#         paths:
#             - test-result.xml
#         reports:
#             junit:
#                 - test-result.xml


VIP:
    stage: build
    dependencies: [] # do not download artifacts from previous jobs
    tags:
        - LV2014
    script:

    #
    # Build vip
    #
        - g-cli --lv-ver 2014 --timeout 30000 BuildVip -- -VipbFile "$CI_PROJECT_DIR\$LV_PROJECT_NAME.vipb" -LabviewVersion "14.0" -wd "$CI_PROJECT_DIR"
    rules:
        - if: '$CI_COMMIT_BRANCH =~ /^release|^hotfix/'
        - if: '$CI_COMMIT_BRANCH == "develop"'
        - if: '$CI_COMMIT_MESSAGE =~ /(?i)\[force build\]/'
    artifacts:
        name: "$CI_PROJECT_TITLE-$CI_COMMIT_REF_SLUG-$CI_COMMIT_SHORT_SHA-VIP"
        paths:
            - $CI_PROJECT_DIR/Builds
    timeout: 1h


persist-tag-artifacts for VIP:
  # Use this job to specify artifacts that should never expire because linked to a release.
  # Naming is important, be cautious with any modification
  stage: post-artifacts-creation
  tags:
        - LV2014
  dependencies: [VIP] # download artifacts from previous jobs
  rules:
    - if: '$CI_COMMIT_BRANCH =~ /^release\/|^hotfix\//'
  script:
    - echo "Persisting artifacts for release"
  artifacts:
    # Specify artifacts from previous jobs to be persisted indefinitely
    name: "$CI_PROJECT_TITLE-$CI_COMMIT_REF_SLUG-$CI_COMMIT_SHORT_SHA-VIP"
    paths:
        - $CI_PROJECT_DIR/Builds
    expire_in: never


release_job:
    stage: release
    tags:
        - LV2014
    dependencies: [] # do not download artifacts from previous jobs
    script:
      - g-cli --lv-ver 2014 CreateRelease -- -tag "$CI_COMMIT_TAG" -private-token "$TOKEN" -project-namespace "$CI_PROJECT_NAMESPACE" -project-name "$CI_PROJECT_NAME" -artifacts "VIP"  
    rules:
      - if: $CI_COMMIT_TAG =~ /(?i)[Vv][0-9]+\.[0-9]+\.[0-9]/


Close LV:
    stage: cleanup
    dependencies: [] # do not download artifacts from previous jobs
    tags:
        - LV2014
    script:
        - g-cli --lv-ver 2014 quitLabVIEW
    when: always
    allow_failure: true